if(!de) var de={};
if(!de.soerenrinne) de.soerenrinne={};
if(!de.soerenrinne.GoogleButtons) de.soerenrinne.GoogleButtons={};

de.soerenrinne.GoogleButtons = function(){
	
	var pub = {};
	
	var googlebuttonsPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("de.soerenrinne.googlebuttons.");
	
	const gsClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"].getService(Components.interfaces.nsIClipboardHelper);
	
	var servicesList = googlebuttonsPrefs.getCharPref('wholeshebang');
	var soerenrinneServicesArray = new Array();
	soerenrinneServicesArray = servicesList.split(',');
	soerenrinneServicesArray.sort(function(x,y){ 
		var a = String(x).toUpperCase(); 
		var b = String(y).toUpperCase(); 
		if (a > b) 
			return 1 
		if (a < b) 
			return -1 
		return 0; 
	});
	if (servicesList != "")
		var soerenrinneNumberOfServices = soerenrinneServicesArray.length;
	else
		var soerenrinneNumberOfServices = 0;
	
	var buttonsList = googlebuttonsPrefs.getCharPref('userlist');
	var soerenrinneButtonsArray = new Array();
	soerenrinneButtonsArray = buttonsList.split(',');
	if (buttonsList != "")
		var soerenrinneNumberOfButtons = soerenrinneButtonsArray.length;
	else
		var soerenrinneNumberOfButtons = 0;
		
	var popupTimer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
	
	PrefListener = function(branchName, func)
	{
		var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var branch = prefService.getBranch(branchName);
		branch.QueryInterface(Components.interfaces.nsIPrefBranch2);
	
		this.register = function()
		{
			branch.addObserver("", this, false);
			branch.getChildList("", { })
				  .forEach(function (name) { func(branch, name); });
		};
	
		this.unregister = function unregister()
		{
			if (branch)
				branch.removeObserver("", this);
		};
	
		this.observe = function(subject, topic, data)
		{
			if (topic == "nsPref:changed")
				func(branch, data);
		};
	}
	
	pub.GoogleButtons_renew = function() {
		
		try {
			if (document.getElementById('GIcon') != null) {
				document.getElementById('GIcon').hidden = true;
			}
			
			var id = "none";
			
			// get new list
			buttonsList = googlebuttonsPrefs.getCharPref('userlist');
			soerenrinneButtonsArray = buttonsList.split(',');
			if (buttonsList != "")
				soerenrinneNumberOfButtons = soerenrinneButtonsArray.length;
			else 
				soerenrinneNumberOfButtons = 0;
				
			var settingsString = "Settings";
			
			try {
				// Get the <stringbundle> element in the XUL document
				var strBundle = document.getElementById("string-bundle");
				
				// Get the UI string
				settingsString = strBundle.getString("settings");
			} catch (e) {}
			
			// Remove all toolbar items
			if (document.getElementById("googlebuttonsOrientation") != null) {
				var element = document.getElementById("googlebuttonsOrientation");
				while(element.hasChildNodes()){
					element.removeChild(element.firstChild);
				}
			}
			
			// Add toolbar items
			if (document.getElementById("googlebuttonsOrientation") != null) {
				// add dummy to toolbar
				var box = document.getElementById("googlebuttonsOrientation"); // a <menupopup> element
				var child = create_ToolbarButton("dummy1", "dummy", "true", "open_website(event, '');", "dummy");
				box.insertBefore(child, box.lastChild);
				// add the rest
				for (var j=0; j<soerenrinneNumberOfButtons; j++) {
					id = soerenrinneButtonsArray[j];
					try {
						if (id == "Google Shortcuts Settings") {
							var label = settingsString;
							if (googlebuttonsPrefs.prefHasUserValue("Google Shortcuts Settings_newname"))
								label = googlebuttonsPrefs.getCharPref("Google Shortcuts Settings_newname");
							var tooltip = settingsString;
							var idStripped = id.replace(/\ /g, "").toLowerCase();
							child = create_ToolbarButton(idStripped+"1", tooltip, "false", "open_settings(event);", tooltip);
						} else if (id == "separator") {
							child = create_ToolbarSeparator();
							box.insertBefore(child, box.lastChild);
						} else {
							var tooltip = googlebuttonsPrefs.getCharPref(id + "_tooltip");
							var idStripped = id.replace(/\ /g, "").toLowerCase();
							child = create_ToolbarButton(idStripped+"1", tooltip, "false", "open_website(event, '" + id + "_url');", id);
						}
						
						if (document.getElementById(idStripped+"1") == null && id != "separator") {
							box.insertBefore(child, box.lastChild);
							if (googlebuttonsPrefs.getBoolPref("subtitleposbottom"))
							{
								document.getElementById(idStripped+"1").setAttribute("orient", "vertical");
							} else {
								document.getElementById(idStripped+"1").setAttribute("orient", "horizontal");
							}
						}
					} catch (e) {
						if (id != "Shopping")
							alert("Error on adding toolbar element:\n" + e.name + ", " + e.message + "\n\nid: " + id);
					}
				}
			}
			
			// Remove all dropdown menu items
			if (document.getElementById("googlebuttons_menupopup") != null) {
				var element = document.getElementById("googlebuttons_menupopup");
				while(element.hasChildNodes()){
					element.removeChild(element.firstChild);
			}
				}
			
			// Add menu items
			if (document.getElementById("googlebuttons_menupopup") != null) {
				// Add dummy to menu
				var menupopup = document.getElementById("googlebuttons_menupopup");
				var child = create_MenuItem("dummy", "dummy", "This is a dummy", "true", "open_website(event, '');");
				menupopup.insertBefore(child, menupopup.lastChild);
				// Add the rest
				for (var j=0; j<soerenrinneNumberOfButtons; j++) {
					id = soerenrinneButtonsArray[j];
					try {
						if (id == "Google Shortcuts Settings") {
							var label = "Google Shortcuts " + settingsString;
							if (googlebuttonsPrefs.prefHasUserValue("Google Shortcuts Settings_newname"))
								label = googlebuttonsPrefs.getCharPref("Google Shortcuts Settings_newname");
							var tooltip = settingsString;
							var idStripped = id.replace(/\ /g, "").toLowerCase();
							child = create_MenuItem(idStripped, label, tooltip, "false", "open_settings(event);");
						} else if (id == "separator") {
							child = create_MenuSeparator();
							menupopup.insertBefore(child, menupopup.lastChild);
						} else {
							var tooltip = googlebuttonsPrefs.getCharPref(id + "_tooltip");
							var idStripped = id.replace(/\ /g, "").toLowerCase();
							child = create_MenuItem(idStripped, id, tooltip, "false", "open_website(event, '" + id + "_url');");
						}
						
						if (document.getElementById(idStripped) == null && id != "separator") {
							menupopup.insertBefore(child, menupopup.lastChild);
						}
					} catch (e) {
						if (id != "Shopping")
							alert("Error on adding menu element:\n" + e.name + ", " + e.message + "\n\nid: " + id);
					}
				}
			}
			
			// Cosmetics
			if (googlebuttonsPrefs.getBoolPref('dropdown') == true) {
				if (document.getElementById('googlebuttonsOrientation') != null && document.getElementById('googlebuttonsdropdownmenu') != null)
				{
					document.getElementById('googlebuttonsOrientation').hidden = true;
					document.getElementById('googlebuttonsdropdownmenu').hidden = false;
				}
			} else {
				if (document.getElementById('googlebuttonsOrientation') != null && document.getElementById('googlebuttonsdropdownmenu') != null)
				{
					document.getElementById('googlebuttonsOrientation').hidden = false;
					document.getElementById('googlebuttonsdropdownmenu').hidden = true;
				}
			}
			
			// set correct toolbar icon
			if (googlebuttonsPrefs.getCharPref('toolbaricon') != "")
				if (document.getElementById('googlebuttonsdropdownmenu') != null)
					document.getElementById('googlebuttonsdropdownmenu').image = googlebuttonsPrefs.getCharPref('toolbaricon');
			
			if (googlebuttonsPrefs.getBoolPref('orient_horizontally') == true)
			{
				if (document.getElementById('googlebuttonsOrientation') != null)
					document.getElementById('googlebuttonsOrientation').orient = "horizontal";
			}
			else
			{
				if (document.getElementById('googlebuttonsOrientation') != null)
					document.getElementById('googlebuttonsOrientation').orient = "vertical";
			}
			
			if (googlebuttonsPrefs.getBoolPref("noarrow") == true) {
				if (document.getElementById('googlebuttonsdropdownmenu') != null)
					document.getElementById('googlebuttonsdropdownmenu').setAttribute("noarrow", true);
			} else {
				if (document.getElementById('googlebuttonsdropdownmenu') != null)
					document.getElementById('googlebuttonsdropdownmenu').setAttribute("noarrow", false);
			}
			
			
			// Look for custom buttons and change the icon to favicon
			var GS_toolbarItem = "";
			var GS_menuItem = "";
			var GS_url = '';
			var CustomCount = googlebuttonsPrefs.getCharPref("CustomCount");
			for (var z = 1; z <= CustomCount; z++) {
				GS_toolbarItem = "custombutton"+ z + "1";
				GS_menuItem = "custombutton"+ z;
				GS_url = 'Custom Button ' + z + '_url';
				if (document.getElementById(GS_toolbarItem) != null || document.getElementById(GS_menuItem) != null) {
					if (googlebuttonsPrefs.prefHasUserValue("Custom Button " + z + "_image")) {
						// load image
						var imagePath = googlebuttonsPrefs.getCharPref("Custom Button " + z + "_image");
						var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
						file.initWithPath(imagePath);
						if(file.exists()) {
							if (document.getElementById(GS_toolbarItem)) {
								document.getElementById(GS_toolbarItem).setAttribute('image', "file:///" + imagePath);
							}
							if (document.getElementById(GS_menuItem)) {
								document.getElementById(GS_menuItem).setAttribute('image', "file:///" + imagePath);
							}
						}
					} else {
						// get favicon
						getFaviconFromURLAndSet(GS_toolbarItem, GS_menuItem, GS_url);
					}
				}
			}
			
		} catch (e) {
				alert("Error on switching in renew:\n" + e.name + ", " + e.message + "\nid: " + id);
		}
	}
	
	getFaviconFromURLAndSet = function(GS_toolbarItem, GS_menuItem, GS_url) {
		var url = googlebuttonsPrefs.getCharPref(GS_url);
		if (url == "")
			return;
		
		var imageURI = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
		var uriLink = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
		uriLink.spec = url;
		imageURI.spec = "http://" + uriLink.host + "/favicon.ico";

		var uriChecker = Components.classes["@mozilla.org/network/urichecker;1"].createInstance().QueryInterface(Components.interfaces.nsIURIChecker);
		var uriChecker2 = Components.classes["@mozilla.org/network/urichecker;1"].createInstance().QueryInterface(Components.interfaces.nsIURIChecker);
		try {
			uriChecker.init(imageURI);
			uriChecker2.init(imageURI);
			if (document.getElementById(GS_toolbarItem) != null)
				uriChecker.asyncCheck(new faviconURIChecker(imageURI, GS_toolbarItem), null);
			if (document.getElementById(GS_menuItem) != null)
				uriChecker2.asyncCheck(new faviconURIChecker(imageURI, GS_menuItem), null);
		}
		catch (e) {
			alert("Error on getting favicon:\n" + e.name + ", " + e.message + "\n\n" + url);
		}
	}
	
	pub.GoogleButtons_onUnLoad = function() {
		myListener.unregister();
	}
	
	pub.GoogleButtons_onLoad = function() {
		// automatically add GS to the toolbar, if it is not there. but only once!
		if (googlebuttonsPrefs.getBoolPref('firstLoad')) {
			try {
				var firefoxnav = document.getElementById("nav-bar");
				var curSet = firefoxnav.currentSet;
				if (curSet.indexOf("GoogleShortcuts_button_set") == -1) {
					var set;
					// place GS before the urlbar
					if (curSet.indexOf("urlbar-container") != -1)
						set = curSet.replace(/urlbar-container/, "GoogleShortcuts_button_set,urlbar-container");
					else  // at the end
						set = curSet + ",GoogleShortcuts_button_set";
					
					firefoxnav.setAttribute("currentset", set);
					firefoxnav.currentSet = set;
					document.persist("nav-bar", "currentset");
					
					// If you don't do the following call, funny things happen
					try {
						BrowserToolboxCustomizeDone(true);
					}
					catch (e) {	alert("Error on automatic adding (inner try):\n" + e.name + ", " + e.message); }
				}
				googlebuttonsPrefs.setBoolPref('firstLoad', false);
			}
			catch(e) { alert("Error on automatic adding:\n" + e.name + ", " + e.message); }
		}
		// add/re-add buttons
		pub.GoogleButtons_renew();
	}
	
	pub.hoverPopup = function() {
		if(googlebuttonsPrefs.getBoolPref('openDropdownOnHover')) {
			popupTimer.cancel();
			var x = document.getElementById("googlebuttonsdropdownmenu").firstChild;
			x.openPopup(x,'after_start',null,null,true,false);
		}
	}
	
	pub.hoverOutPopup = function() {
		if(googlebuttonsPrefs.getBoolPref('openDropdownOnHover')) {
			var event = { notify: function(timer) { var popup = document.getElementById("googlebuttonsdropdownmenu").firstChild; popup.hidePopup(); } };
			
			popupTimer.initWithCallback(event, 500, Components.interfaces.nsITimer.TYPE_ONE_SHOT);
		}
	}
	
	// First run function
	pub.GoogleButtons_OpenFirstRunPage = function() {		
		var VERSION = "2.1.5";
		var URL = "http://www.soerenrinne.de/GoogleShortcuts/update.html?version=" + VERSION;

		var pref = googlebuttonsPrefs;
		
		var event = { notify: function(timer) { window.openUILinkIn(URL, "tab"); } };
		
		var timer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
		var prefVersion = "";
		
		try {
			prefVersion = pref.getCharPref("version");
		} catch (e) {}
		
		if(prefVersion != VERSION) {
			// different version
			// open website only on non-beta-versions
			if (VERSION.search("b") == -1)
				timer.initWithCallback(event, 500, Components.interfaces.nsITimer.TYPE_ONE_SHOT);
			// set current version number in prefs
			pref.setCharPref("version", VERSION);
		
			try {
				// generate new wholeshebang list based on userlist and completelist
				var wholeshebang = "";
				var completelist = pref.getCharPref("completelist");
				var userlist = pref.getCharPref("userlist");
				
				var completelistArray = new Array();
				completelistArray = completelist.split(',');
				var userlistArray = new Array();
				userlistArray = userlist.split(',');
				
				for (var i = 0; i<completelistArray.length; i++) {
					if (userlistArray.indexOf(completelistArray[i]) == "-1") {
						wholeshebang = wholeshebang + (wholeshebang ? "," : "") + completelistArray[i];
					}
				}
				
				pref.setCharPref("wholeshebang", wholeshebang);
				
				// set new array
				servicesList = googlebuttonsPrefs.getCharPref('wholeshebang');
				soerenrinneServicesArray = servicesList.split(',');
				soerenrinneServicesArray.sort(function(x,y){ 
					var a = String(x).toUpperCase(); 
					var b = String(y).toUpperCase(); 
					if (a > b) 
						return 1 
					if (a < b) 
						return -1 
					return 0; 
				});
				soerenrinneNumberOfServices = soerenrinneServicesArray.length;
				
				if (!pref.prefHasUserValue("version")) {
					//no version found
					timer.initWithCallback(event, 500, Components.interfaces.nsITimer.TYPE_ONE_SHOT);
					pref.setCharPref("version", VERSION);
				} else {
					if (pref.getCharPref("version").substr(0,1) == "1")	{
						//old 1.*.* version found -> compatibility mode to fetch old service settings and put them in two new lists
						var listString = "";
						var oldList = pref.getCharPref("completelist");
						// only needed for j
						var tempArray = new Array();
						tempArray = oldList.split(',');
						tempArray.sort(function(x,y){ 
							var a = String(x).toUpperCase(); 
							var b = String(y).toUpperCase(); 
							if (a > b) 
								return 1 
							if (a < b) 
								return -1 
							return 0; 
						});
						
						oldList += ",";
						
						for (var j=0; j<tempArray.length; j++) {
							var id = tempArray[j];
							var selected = false;
							
							try {
								selected = pref.getBoolPref(id);
							} catch (e) {}
							
							if (selected) {
								// add to new list
								listString = listString + (listString ? "," : "") + id;
								// remove from old list (wholeshebang)
								oldList = oldList.replace(id + ",", "");
								//alert("id:\n" + id + "\nlistString:\n" + listString);
							}
						}
						if (pref.getBoolPref("settings"))
							listString = listString + (listString ? "," : "") + "Google Shortcuts Settings";
						else
							oldList += "Google Shortcuts Settings,";
						
						if (listString != "") {
							// save user selection for right tree
							pref.setCharPref("userlist", listString);
							// save wholeshebang for left tree
							oldList = oldList.substr(0, oldList.length - 1)
							pref.setCharPref("wholeshebang", oldList);
						}
					}
					if (pref.getCharPref("version").substr(0,3) == "2.0")
					{
						// renamed shopping into product search in version 2.0.1
						userlist = pref.getCharPref("userlist");
						
						try {
							selected = pref.getBoolPref("Shopping");
						} catch (e) {}
						if (selected || userlist.search("Shopping")) {
							if (pref.prefHasUserValue("Shopping"))
								pref.setBoolPref("Shopping", false);
							userlist = userlist.replace("Shopping", "Product Search");
							pref.setCharPref("userlist", userlist);
						}
						
						// renamed local business center into places in version 2.0.2
						userlist = pref.getCharPref("userlist");
						
						try {
							selected = pref.getBoolPref("Local Business Center");
						} catch (e) {}
						if (selected || userlist.search("Local Business Center")) {
							if (pref.prefHasUserValue("Local Business Center"))
								pref.setBoolPref("Local Business Center", false);
							userlist = userlist.replace("Local Business Center", "Places");
							pref.setCharPref("userlist", userlist);
						}
						
						// removed settings & custom buttons from left tree						
						if (!pref.prefHasUserValue("CustomCount")) {
							userlist = pref.getCharPref("userlist");
							try {
								selected = pref.prefHasUserValue("Custom 1_url");
							} catch (e) {}
							if (selected || userlist.search("Custom 1")) {
								if (pref.prefHasUserValue("Custom 1_url")) {
									pref.setCharPref("Custom Button 1_url", pref.getCharPref("Custom 1_url"));
									pref.setCharPref("Custom Button 1_tooltip", "This is a custom button");
									pref.clearUserPref("Custom 1_url");
								}
								userlist = userlist.replace("Custom 1", "Custom Button 1");
								pref.setCharPref("userlist", userlist);
								pref.setCharPref("CustomCount", "1");
							}
							try {
								selected = pref.prefHasUserValue("Custom 2_url");
							} catch (e) {}
							if (selected || userlist.search("Custom 2")) {
								if (pref.prefHasUserValue("Custom 2_url")) {
									pref.setCharPref("Custom Button 2_url", pref.getCharPref("Custom 2_url"));
									pref.setCharPref("Custom Button 2_tooltip", "This is a custom button");
									pref.clearUserPref("Custom 2_url");
								}
								userlist = userlist.replace("Custom 2", "Custom Button 2");
								pref.setCharPref("userlist", userlist);
								pref.setCharPref("CustomCount", "2");
							}
						}
						// old settings button in wholeshebang?
						wholeshebang = pref.getCharPref("wholeshebang");
						if (wholeshebang.search(",Google Shortcuts Settings")) {
							wholeshebang = wholeshebang.replace(",Google Shortcuts Settings", "");
							pref.setCharPref("wholeshebang", wholeshebang);
						}
						
					}
				}
				
				// remove listener after calling
				window.removeEventListener("load", de.soerenrinne.GoogleButtons.GoogleButtons_OpenFirstRunPage, false);
			} catch (e) {
				alert("Error onFirstRun:\n" + e.name + ", " + e.message);
			}
		}
	}
	
	faviconURIChecker = function (img, id) {
		this.img = img;
		this.id = id;
		this.onStartRequest = function (request, context) {};
		this.onStopRequest = function (request, context, status) {
			var GS_item = document.getElementById(this.id);
			//alert("GS_item: " + GS_item);
			if (status == 0 && GS_item) {
				GS_item.setAttribute('image', this.img.spec);
				//alert(this.id + "\n" + this.img.spec);
			}
		};
	}
	
	/* following two functions inspired by goo.gl lite by Matthew Flaschen */	
	notify = function(text, priorityKey)
	{
		var notifyBox = window.getNotificationBox(top.getBrowser().selectedBrowser.contentWindow);
		notifyBox.removeAllNotifications(false);
		notifyBox.appendNotification("Google Shortcuts: " + text, this.notificationValue, this.iconURL, notifyBox[priorityKey], null);
		
		// remove automatically after 3 seconds
		var event = { notify: function(timer) { notifyBox.removeAllNotifications(false); } }
		var timer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
		
		timer.initWithCallback(event, 7000, Components.interfaces.nsITimer.TYPE_ONE_SHOT);
	}

	error = function(error_text)
	{
		this.notify("Short URL creation failed. " + error_text, "PRIORITY_WARNING_MEDIUM");
		throw new Error("Short URL creation failed. " + error_text);
	}

	make_short_url = function()	{
		
		/*
		// older code, but makes a "quoata exceeded" error
		long_url = top.getBrowser().currentURI.spec;
		var req = new XMLHttpRequest();
		req.addEventListener("load", function()
		{
			var response = JSON.parse(req.responseText);
			if(response.error_message)
			{
				error("Service returned error message: " + response.error_message);
			}
			notify(response.short_url + " has been copied to the clipboard. (Original URL: " + long_url + ")", "PRIORITY_INFO_MEDIUM");
			gsClipboardHelper.copyString(response.short_url);
		}, false);
		req.addEventListener("error", function()
		{
			error("Error contacting service. Status code: " + req.status);
		}, false);
		req.open("GET", "http://ggl-shortener.appspot.com/?url=" + encodeURIComponent(long_url));

		req.send();*/
		
		// new from bookmarklet
		//window.top.getBrowser().loadURI('javascript:window.googl_callback%20=%20function(response){if(response.error_message){alert("%20An%20error%20occured:%20"%20+%20response.error_message);}else{alert(response.short_url);}};%20var%20s%20=%20document.createElement("script");%20s.src%20=%20"http://ggl-shortener.appspot.com/?url="%20+%20encodeURIComponent(window.location.href)%20+%20"&jsonp=googl_callback";%20void(document.body.appendChild(s));');
		
		// even newer, nicer one
		var http = new XMLHttpRequest(),
		taburl = top.getBrowser().currentURI.spec,
		par = shorten(taburl);

		http.open(
			"post",
			"http://goo.gl/api/url",
			false
		);
		http.setRequestHeader("Content-type","application/x-www-form-urlencoded");

		http.onload = function() {
			//var shorturl = JSON.parse(http.responseText).short_url;
			var response = JSON.parse(http.responseText);
			var shorturl = response.short_url;
			if (shorturl != undefined) {
				notify(shorturl + " has been copied to the clipboard. Original URL was: " + taburl, "PRIORITY_INFO_MEDIUM");
				gsClipboardHelper.copyString(shorturl);
			} else {
				error("Service returned error message: " + response.error_message);
			}
		};

		http.send(par);
	}
	
	var shorten = function (b) {
		function c() {
			for (var l = 0, m = 0; m < arguments.length; m++) l = l + arguments[m] & 4294967295;
			return l
		}
		function d(l) {
			l = l = String(l > 0 ? l : l + 4294967296);
			var m;
			m = l;
			for (var o = 0, n = false, p = m.length - 1; p >= 0; --p) {
				var q = Number(m.charAt(p));
				if (n) {
					q *= 2;
					o += Math.floor(q / 10) + q % 10
				} else o += q;
				n = !n
			}
			m = m = o % 10;
			o = 0;
			if (m != 0) {
				o = 10 - m;
				if (l.length % 2 == 1) {
					if (o % 2 == 1) o += 9;
					o /= 2
				}
			}
			m = String(o);
			m += l;
			return l = m
		}
		function e(l) {
			for (var m = 5381, o = 0; o < l.length; o++) m = c(m << 5, m, l.charCodeAt(o));
			return m
		}
		function f(l) {
			for (var m = 0, o = 0; o < l.length; o++) m = c(l.charCodeAt(o), m << 6, m << 16, -m);
			return m
		}
		var g = "au";
		g += "th";
		g += "_";
		g += "to";
		g += "k";
		g += "en";
		var i = e(b);
		i = i >> 2 & 1073741823;
		i = i >> 4 & 67108800 | i & 63;
		i = i >> 4 & 4193280 | i & 1023;
		i = i >> 4 & 245760 | i & 16383;
		var j = "7";
		h = f(b);
		var k = (i >> 2 & 15) << 4 | h & 15;
		k |= (i >> 6 & 15) << 12 | (h >> 8 & 15) << 8;
		k |= (i >> 10 & 15) << 20 | (h >> 16 & 15) << 16;
		k |= (i >> 14 & 15) << 28 | (h >> 24 & 15) << 24;
		j += d(k);
		i = "user=";
		i += "toolbar@google.com";
		i += "&url=";
		i += encodeURIComponent(b);
		i += "&";
		i += g;
		i += "=";
		i += j;
		return i
	};
	
	gmail_this = function () {
		// seems to not work anymore
		/*
		var popw = '';
		var Q = '';
		var extension = 'mail';
		var y = window;
		
		var focusedWindow = document.commandDispatcher.focusedWindow;
    	var Q = focusedWindow.getSelection();
		
		if (googlebuttonsPrefs.getBoolPref("appsMail") && googlebuttonsPrefs.getCharPref("appsDomainName") != "")
			extension = "a/" + googlebuttonsPrefs.getCharPref("appsDomainName");
		
		popw = y.open('https://mail.google.com/' + extension + '/?view=cm&fs=1&tf=1&to=&su=' + escape(document.title) + '&body=' + escape(Q) + escape('\n\nLink: ') + escape(top.getBrowser().currentURI.spec) + ' (via Google Shortcuts Firefox extension)' +'&zx=RANDOMCRAP&shva=1&disablechatbrowsercheck=1&ui=1','gmailForm','scrollbars=yes,width=680,height=510,top=175,left=75,status=no,resizable=yes');
		if (!document.all) {
			var event = { notify: function(timer) { popw.focus(); } }
			var timer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
			
			timer.initWithCallback(event, 50, Components.interfaces.nsITimer.TYPE_ONE_SHOT);
		}*/
		window.top.getBrowser().loadURI("javascript:popw='';Q='';x=document;y=window;if(x.selection) {Q=x.selection.createRange().text;} else if (y.getSelection) {Q=y.getSelection();} else if (x.getSelection) {Q=x.getSelection();}popw = y.open('https://mail.google.com/mail/?ui=2&view=cm&to=&tf=0&su=' + escape(document.title) + '&body=' + escape(Q) + escape('\n\n') + escape(location.href) + escape('\n\n(via Google Shortcuts Firefox extension)'),'gmailForm','scrollbars=yes,width=680,height=510,top=175,left=75,status=no,resizable=yes');if (!document.all) T = setTimeout('popw.focus()',50);void(0);");
	}
	
	greader_this = function () {
		window.top.getBrowser().loadURI("javascript:var%20b=document.body;var%20GR________bookmarklet_domain='https://www.google.com';if(b&&!document.xmlVersion){void(z=document.createElement('script'));void(z.src='https://www.google.com/reader/ui/link-bookmarklet.js');void(b.appendChild(z));}else{}");
	}
	
	gnotebook_this = function () {
		window.top.getBrowser().loadURI("javascript:(function(){var%20w=window;var%20d=document;var%20g=w.open('about:blank','gnotesWin','location=0,menubar=0,scrollbars=0,status=0,toolbar=0,width=300,height=300,resizable');var%20s=d.createElement('script');s.setAttribute('src','http://www.google.com/notebook/bookmarkletPoster?zx='+(new%20Date()).valueOf());d.body.appendChild(s);w.setTimeout(function(){w.blur();g.focus();},%20100)}).call({});");
	}
	
	gbuzz_this = function () {
		var buzz_message = content.document.title;
		
		if (content.getSelection() != '') {
			var buzz_messageSignature = "\n\n" + content.getSelection() + "\n\n(via Google Shortcuts)";
		} else {
			var buzz_messageSignature = "\n\n(via Google Shortcuts)";
		}
		
		buzz_message += buzz_messageSignature;
		buzz_message = encodeURIComponent(buzz_message).replace(/\n/g,"%0A").replace(/\r/g,"%0D");

		var buzz_widgetUrl = 'http://www.google.com/buzz/post?message='+buzz_message+'&url='+encodeURIComponent(content.location.href);
		window.open(buzz_widgetUrl,'buzz_this','width=690,height=415');
	}
	
	coop_this = function() {
		window.top.getBrowser().loadURI("javascript:(function(){var%20a=window,b=document,c=encodeURIComponent,d=a.open('http://www.google.com/coop/bml?url='+c(b.location)%20+%20'','coop_popup','left='+((a.screenX||a.screenLeft)+10)+',top='+((a.screenY||a.screenTop)+10)+',height=420px,width=700px,resizable=1,alwaysRaised=1,scrollbars=1');a.setTimeout(function(){d.focus()},300)})();");
	}
	
	gmark_this = function() {
		window.top.getBrowser().loadURI('javascript:(function(){var%20des=function(){var%20mes=document.getElementsByTagName("meta");for(var%20i=0,me;me=mes[i];i++){mea=me.getAttribute("name");if(mea%20&&%20mea.toUpperCase()=="DESCRIPTION"){return%20me.getAttribute("content");}}return%20"";}();var%20a=window,b=document,c=encodeURIComponent,cc=encodeURI,d=a.open("https://www.google.com/bookmarks/api/bookmarklet?output=popup&srcUrl="+c(b.location)+%20"&snippet="+c(des)+"&title="+c(b.title),"bkmk_popup","left="+((a.screenX||a.screenLeft)+10)+",top="+((a.screenY||a.screenTop)+10)+",height=460px,width=550px,resizable=1,alwaysRaised=1");a.setTimeout(function(){d.focus()},300)})();');
	}
	
	bookmark_this = function() {
		window.top.getBrowser().loadURI('javascript:(function(){var%20a=window,b=document,c=encodeURIComponent,d=a.open("http://www.google.com/bookmarks/mark?op=edit&output=popup&bkmk="+c(b.location)+"&title="+c(b.title),"bkmk_popup","left="+((a.screenX||a.screenLeft)+10)+",top="+((a.screenY||a.screenTop)+10)+",height=420px,width=550px,resizable=1,alwaysRaised=1");a.setTimeout(function(){d.focus()},300)})();');
	}
	
	map_this = function() {
		window.top.getBrowser().loadURI('javascript:d=""+(window.getSelection?window.getSelection():document.getSelection?document.getSelection():document.selection.createRange().text);d=d.replace(/\\n|\\r\\n|\\r/g,",%20");if(!d)d=prompt("Enter%20the%20address:",%20"");if(d!=null)location="http://maps.google.com?q="+encodeURI(d).replace(/%20/g,"+");void%200');
	}
	
	open_website = function(event, url) {
	
		var btnCode = event.button;
		var browser = document.getElementById("content");
		var prefs_url = googlebuttonsPrefs.getCharPref(url);
		
		// check Apps settings
		if (prefs_url == "http://www.google.com/apps" && googlebuttonsPrefs.getCharPref("appsDomainName") != "") {
			prefs_url = "http://www.google.com/a/" + googlebuttonsPrefs.getCharPref("appsDomainName");
		}
		else if (prefs_url == "https://mail.google.com" && googlebuttonsPrefs.getBoolPref("appsMail") && googlebuttonsPrefs.getCharPref("appsDomainName") != "") {
			prefs_url = "https://mail.google.com/a/" + googlebuttonsPrefs.getCharPref("appsDomainName");
		}
		else if (prefs_url == "https://mail.google.com/mail/?ui=1&view=cm&fs=1&tf=1" && googlebuttonsPrefs.getBoolPref("appsMail") && googlebuttonsPrefs.getCharPref("appsDomainName") != "") {
			prefs_url = "https://mail.google.com/a/" + googlebuttonsPrefs.getCharPref("appsDomainName") + "/?ui=1&view=cm&fs=1&tf=1";
		}
		else if (prefs_url == "http://www.google.com/calendar/render" && googlebuttonsPrefs.getBoolPref("appsCal") && googlebuttonsPrefs.getCharPref("appsDomainName") != "") {
			prefs_url = "https://www.google.com/calendar/hosted/" + googlebuttonsPrefs.getCharPref("appsDomainName");
		}
		else if (prefs_url == "http://www.google.com/calendar/event?ctext=&action=TEMPLATE&pprop=HowCreated:QUICKADD" && googlebuttonsPrefs.getBoolPref("appsCal") && googlebuttonsPrefs.getCharPref("appsDomainName") != "") {
			prefs_url = "http://www.google.com/calendar/a/" + googlebuttonsPrefs.getCharPref("appsDomainName") + "/event?ctext=&action=TEMPLATE&pprop=HowCreated:QUICKADD";
		}
		else if (prefs_url == "http://docs.google.com" && googlebuttonsPrefs.getBoolPref("appsDocs") && googlebuttonsPrefs.getCharPref("appsDomainName") != "") {
			prefs_url = "https://docs.google.com/a/" + googlebuttonsPrefs.getCharPref("appsDomainName");
		}
		else if (prefs_url == "http://docs.google.com/document/create" && googlebuttonsPrefs.getBoolPref("appsDocs") && googlebuttonsPrefs.getCharPref("appsDomainName") != "") {
			prefs_url = "http://docs.google.com/a/" + googlebuttonsPrefs.getCharPref("appsDomainName") + "/document/create";
		}
		else if (prefs_url == "http://docs.google.com/?action=new_presentation" && googlebuttonsPrefs.getBoolPref("appsDocs") && googlebuttonsPrefs.getCharPref("appsDomainName") != "") {
			prefs_url = "http://docs.google.com/a/" + googlebuttonsPrefs.getCharPref("appsDomainName") + "/?action=new_presentation";
		}
		else if (prefs_url == "http://spreadsheets.google.com/ccc?new=true" && googlebuttonsPrefs.getBoolPref("appsDocs") && googlebuttonsPrefs.getCharPref("appsDomainName") != "") {
			prefs_url = "http://spreadsheets.google.com/a/" + googlebuttonsPrefs.getCharPref("appsDomainName") + "/ccc?new=true";
		}
		else if (prefs_url == "http://spreadsheets.google.com/newform" && googlebuttonsPrefs.getBoolPref("appsDocs") && googlebuttonsPrefs.getCharPref("appsDomainName") != "") {
			prefs_url = "http://spreadsheets.google.com/a/" + googlebuttonsPrefs.getCharPref("appsDomainName") + "/newform";
		}
		else if (prefs_url == "http://docs.google.com/drawings/create" && googlebuttonsPrefs.getBoolPref("appsDocs") && googlebuttonsPrefs.getCharPref("appsDomainName") != "") {
			prefs_url = "http://docs.google.com/a/" + googlebuttonsPrefs.getCharPref("appsDomainName") + "/drawings/create";
		}
		else if (prefs_url == "http://docs.google.com/templates" && googlebuttonsPrefs.getBoolPref("appsDocs") && googlebuttonsPrefs.getCharPref("appsDomainName") != "") {
			prefs_url = "http://docs.google.com/a/" + googlebuttonsPrefs.getCharPref("appsDomainName") + "/templates";
		}
		else if (prefs_url == "http://www.google.com/contacts" && googlebuttonsPrefs.getBoolPref("appsContacts") && googlebuttonsPrefs.getCharPref("appsDomainName") != "") {
			prefs_url = "https://www.google.com/contacts/a/" + googlebuttonsPrefs.getCharPref("appsDomainName");
		}
		else if (prefs_url == "http://sites.google.com/site/sites/" && googlebuttonsPrefs.getBoolPref("appsSites") && googlebuttonsPrefs.getCharPref("appsDomainName") != "") {
			prefs_url = "https://sites.google.com/a/" + googlebuttonsPrefs.getCharPref("appsDomainName");
		}
		else if (prefs_url == "http://groups.google.com" && googlebuttonsPrefs.getBoolPref("appsGroups") && googlebuttonsPrefs.getCharPref("appsDomainName") != "") {
			prefs_url = "https://groups.google.com/a/" + googlebuttonsPrefs.getCharPref("appsDomainName") + "/";
		}
		else if (prefs_url == "http://video.google.com" && googlebuttonsPrefs.getBoolPref("appsVideo") && googlebuttonsPrefs.getCharPref("appsDomainName") != "") {
			prefs_url = "https://video.google.com/a/" + googlebuttonsPrefs.getCharPref("appsDomainName");
		}
		else if (prefs_url == "https://mail.google.com/tasks/canvas?pli=1" && googlebuttonsPrefs.getBoolPref("appsTasks") && googlebuttonsPrefs.getCharPref("appsDomainName") != "") {
			prefs_url = "https://mail.google.com/tasks/a/" + googlebuttonsPrefs.getCharPref("appsDomainName") + "/canvas?pli=1";
		}
		else if (prefs_url == "https://wave.google.com" && googlebuttonsPrefs.getBoolPref("appsWave") && googlebuttonsPrefs.getCharPref("appsDomainName") != "") {
			prefs_url = "https://wave.google.com/a/" + googlebuttonsPrefs.getCharPref("appsDomainName");
		}
		// check goo.gl
		else if (prefs_url == "goo.gl - not changeable") {
			/* inspired by goo.gl lite by Matthew Flaschen */
			try {
				make_short_url();
			} catch (e) {
				alert("Error onGoo.gl:\n" + e.name + ", " + e.message);
			}
			return;
		}
		// check gmail this
		else if (prefs_url == "gmail this - not changeable") {
			try {
				gmail_this();
			} catch (e) {
				alert("Error onGmailThis:\n" + e.name + ", " + e.message);
			}
			return;
		}
		// check greader this
		else if (prefs_url == "greader this - not changeable") {
			try {
				greader_this();
			} catch (e) {
				alert("Error onGReaderThis:\n" + e.name + ", " + e.message);
			}
			return;
		}
		// check gnotebook this
		else if (prefs_url == "gnotebook this - not changeable") {
			try {
				gnotebook_this();
			} catch (e) {
				alert("Error onGNotebookThis:\n" + e.name + ", " + e.message);
			}
			return;
		}
		// check gbuzz this
		else if (prefs_url == "gbuzz this - not changeable") {
			try {
				gbuzz_this();
			} catch (e) {
				alert("Error onGBuzzThis:\n" + e.name + ", " + e.message);
			}
			return;
		}
		// check coop this
		else if (prefs_url == "coop this - not changeable") {
			try {
				coop_this();
			} catch (e) {
				alert("Error onCoopThis:\n" + e.name + ", " + e.message);
			}
			return;
		}
		// check gmark this
		else if (prefs_url == "gmark this - not changeable") {
			try {
				gmark_this();
			} catch (e) {
				alert("Error onGMarkThis:\n" + e.name + ", " + e.message);
			}
			return;
		}
		// check bookmark this
		else if (prefs_url == "bookmark this - not changeable") {
			try {
				bookmark_this();
			} catch (e) {
				alert("Error onBookmarkThis:\n" + e.name + ", " + e.message);
			}
			return;
		}
		// check map this
		else if (prefs_url == "map this - not changeable") {
			try {
				map_this();
			} catch (e) {
				alert("Error onMapThis:\n" + e.name + ", " + e.message);
			}
			return;
		}
		
		var shiftKey = event.shiftKey;
		var ctrlKey = event.ctrlKey;
		if (!ctrlKey) {
			// this may be a mac
			ctrlKey = event.metaKey;
		}
		var focustab = googlebuttonsPrefs.getBoolPref("focustab");
		var alwaysNewTab = googlebuttonsPrefs.getBoolPref("openintab");
		var altKey = event.altKey;
		
		/*
		// always use https
		var alwayshttps = googlebuttonsPrefs.getBoolPref("alwayshttps");
		if(alwayshttps) {
			var temp = prefs_url.substring(0, 5);
			
			if (temp == "http:") {
				prefs_url = "https" + prefs_url.substring(4);
			}
		}
		*/
		
		if(btnCode == 0) { // left mouse button
			if(ctrlKey == true) {
				if(shiftKey == true) {
					// new tab without focus
					browser.addTab(prefs_url);
				} else if (altKey == true) {
					// open in sidebar
					if (prefs_url != "https://mail.google.com/mail/?shva=1#buzz")
						document.getElementById("viewGSSidebar").setAttribute("sidebarurl",prefs_url);
					else {
						// create a Buzz GUI that fits in the sidebar
						prefs_url = "https://m.google.com/app/buzz?source=mog&gl=us&force=1#~buzz:view=following";
						document.getElementById("viewGSSidebar").setAttribute("sidebarurl",prefs_url);
					}
					toggleSidebar('viewGSSidebar', false);
					toggleSidebar('viewGSSidebar', true);
				} else {
					// new tab with focus
					browser.selectedTab = browser.addTab(prefs_url);
				}
			} else if(shiftKey == true) {
				// open in new window
				window.open(prefs_url);
			} else if(alwaysNewTab == true && focustab == false) {
				// new tab with focus
				browser.selectedTab = browser.addTab(prefs_url);
			} else if(alwaysNewTab == true) {
				// new tab without focus
				browser.addTab(prefs_url);
			} else {
				// open in current tab
				browser.loadURI(prefs_url);
			}
		} else if(btnCode == 1) { // middle mouse button
			if(shiftKey == true) {
				// new tab without focus
				browser.addTab(prefs_url);
			} else if(focustab == true){
				// new tab without focus
				browser.addTab(prefs_url);
			} else {
				// new tab with focus
				browser.selectedTab = browser.addTab(prefs_url);
			}
			// in all cases close dropdown menu
			if(document.getElementById("googlebuttons_menupopup")) {
				document.getElementById("googlebuttons_menupopup").hidePopup();
			}
		}
	}
	
	open_settings = function()
	{
		window.openDialog('chrome://googlebuttons/content/googlebuttonsSettings.xul','Settings of Google Shortcuts','chrome,titlebar,toolbar,centerscreen,dialog,modal,alwaysRaised,resizable');
		
		pub.GoogleButtons_renew();
	}
	
	create_ToolbarButton = function(aButtonID, aButtonTooltiptext, aButtonHidden, aButtonOnclick, aButtonLabel) {
		const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
	  	var item = document.createElementNS(XUL_NS, "toolbarbutton"); // create a new XUL toolbarbutton
	  	item.setAttribute("id", aButtonID);
		if(aButtonLabel.substr(0,13) != "Custom Button") {
			if (googlebuttonsPrefs.prefHasUserValue(aButtonLabel + "_newname")) {
				item.setAttribute("tooltiptext", googlebuttonsPrefs.getCharPref(aButtonLabel + "_newname") + " (" + aButtonLabel + ")\n" + aButtonTooltiptext);
				item.setAttribute("label", googlebuttonsPrefs.getCharPref(aButtonLabel + "_newname"));
			}
			else {
				item.setAttribute("tooltiptext", aButtonLabel + "\n" + aButtonTooltiptext);
				item.setAttribute("label", aButtonLabel);
			}
			if (googlebuttonsPrefs.getBoolPref("usenewicons")) {
				if (googlebuttonsPrefs.getBoolPref("usenewicons18px"))
					item.setAttribute("image", "chrome://googlebuttons/skin/newiconset/" + aButtonID.replace("1", "") + "-18.png");
				else
					item.setAttribute("image", "chrome://googlebuttons/skin/newiconset/" + aButtonID.replace("1", "") + "-16.png");
				
			}
			else
				item.setAttribute("image", "chrome://googlebuttons/skin/" + aButtonID.replace("1", "") + ".gif");
		}
		else {
			if (googlebuttonsPrefs.prefHasUserValue(aButtonLabel + "_newname")) {
				item.setAttribute("tooltiptext", googlebuttonsPrefs.getCharPref(aButtonLabel + "_newname") + "\n" + aButtonTooltiptext);
				item.setAttribute("label", googlebuttonsPrefs.getCharPref(aButtonLabel + "_newname"));
			}
			else {
				item.setAttribute("tooltiptext", googlebuttonsPrefs.getCharPref(aButtonLabel + "_url") + "\n" + aButtonTooltiptext);
				item.setAttribute("label", aButtonLabel);
			}
			item.setAttribute("image", "chrome://googlebuttons/skin/custombutton.gif");
		}
		item.setAttribute("hidden", aButtonHidden);
		item.setAttribute("class", "toolbarbutton-1 chromeclass-toolbar-additional googleshortcutstoolbar");
		item.setAttribute("onclick", aButtonOnclick);
		
		if (googlebuttonsPrefs.getBoolPref("subtitleposbottom"))
		{
			item.setAttribute("orient", "vertical");
			if (document.getElementById("settings1") != null) {
				var settingsbutton = document.getElementById("settings1");
				settingsbutton.setAttribute("orient", "vertical");
			}
		} else {
			if (document.getElementById("settings1") != null) {
				var settingsbutton = document.getElementById("settings1");
				settingsbutton.setAttribute("orient", "horizontal");
			}
		}
		item.setAttribute("align", "center");
	  	return item;
	}
	
	create_ToolbarSeparator = function() {
		const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
	  	var item = document.createElementNS(XUL_NS, "toolbarseparator"); // create a new XUL toolbarseparator
		
		return item;
	}
	
	create_MenuItem = function(aMenuID, aMenuLabel, aMenuTooltiptext, aMenuHidden, aMenuOnclick) {
		const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
	  	var item = document.createElementNS(XUL_NS, "menuitem"); // create a new XUL menuitem
	  	item.setAttribute("id", aMenuID);
		item.setAttribute("tooltiptext", aMenuTooltiptext);
		item.setAttribute("hidden", aMenuHidden);
		item.setAttribute("class", "menuitem-iconic bookmark-item");
		if(aMenuLabel.substr(0,13) != "Custom Button") {
			if (googlebuttonsPrefs.prefHasUserValue(aMenuLabel + "_newname"))
				item.setAttribute("label", googlebuttonsPrefs.getCharPref(aMenuLabel + "_newname"));
			else
				item.setAttribute("label", aMenuLabel);
			if (googlebuttonsPrefs.getBoolPref("usenewicons"))
				item.setAttribute("image", "chrome://googlebuttons/skin/newiconset/" + aMenuID + "-16.png");
			else
				item.setAttribute("image", "chrome://googlebuttons/skin/" + aMenuID + ".gif");
		}
		else {
			if (googlebuttonsPrefs.prefHasUserValue(aMenuLabel + "_newname"))
				item.setAttribute("label", googlebuttonsPrefs.getCharPref(aMenuLabel + "_newname"));
			else
				item.setAttribute("label", googlebuttonsPrefs.getCharPref(aMenuLabel + "_url"));
			
			item.setAttribute("image", "chrome://googlebuttons/skin/custombutton.gif");				
		}
		item.setAttribute("onclick", aMenuOnclick);
		//item.setAttribute("src", "chrome://googlebuttons/skin/" + aMenuID + ".gif");
	  	return item;
	}
	
	create_MenuSeparator = function() {
		const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
	  	var item = document.createElementNS(XUL_NS, "menuseparator"); // create a new XUL menuseparator
		
		return item;
	}
	
	// generate observer
	var myListener = new PrefListener("de.soerenrinne.googlebuttons.",
		function(branch, name)
		{
			if (!googlebuttonsPrefs.prefHasUserValue("noupdate"))
				pub.GoogleButtons_renew();
		});
	myListener.register();
	
	return pub;
}();

// localize extension description on startup
window.addEventListener("load",googButtonsInit,false);

function googButtonsInit() {
    var googbuttonsLocalizationPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.{5C46D283-ABDE-4dce-B83C-08881401921C}.");
    var str = Components.classes[ "@mozilla.org/supports-string;1" ].createInstance( Components.interfaces.nsISupportsString );
    str.data = document.getElementById("string-bundle").getString("extdescription");
    googbuttonsLocalizationPrefs.setComplexValue( "description", Components.interfaces.nsISupportsString, str ); 
}
	
window.addEventListener("load", de.soerenrinne.GoogleButtons.GoogleButtons_OpenFirstRunPage, false);
window.addEventListener("load", de.soerenrinne.GoogleButtons.GoogleButtons_onLoad, false);
window.addEventListener("unload",de.soerenrinne.GoogleButtons.GoogleButtons_onUnLoad, false);
